"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Taskbar = void 0;
const lit_1 = require("lit");
const decorators_js_1 = require("lit/decorators.js");
const map_js_1 = require("lit/directives/map.js");
const context_1 = require("@lit/context");
const context_2 = require("../context");
const TaskMap = {
    [context_2.Task.SHOW_LAYERS_PANEL]: {
        icon: (0, lit_1.html) `<sp-icon-layers slot="icon"></sp-icon-layers>`,
        label: 'Show layers panel',
    },
    [context_2.Task.SHOW_PROPERTIES_PANEL]: {
        icon: (0, lit_1.html) `<sp-icon-properties slot="icon"></sp-icon-properties>`,
        label: 'Show properties panel',
    },
};
let Taskbar = class Taskbar extends lit_1.LitElement {
    handleTaskChanged(e) {
        this.api.setTaskbars(e.target.selected);
    }
    render() {
        const { taskbarAll, taskbarSelected } = this.appState;
        return (0, lit_1.html) `
      <sp-action-group
        vertical
        quiet
        selects="multiple"
        .selected=${taskbarSelected}
        @change=${this.handleTaskChanged}
      >
        ${(0, map_js_1.map)(taskbarAll, (task) => {
            const { icon, label } = TaskMap[task];
            return (0, lit_1.html) `<sp-action-button value="${task}">
            ${icon}
            <sp-tooltip self-managed placement="left"> ${label} </sp-tooltip>
          </sp-action-button>`;
        })}
      </sp-action-group>
    `;
    }
};
exports.Taskbar = Taskbar;
Taskbar.styles = (0, lit_1.css) `
    :host {
      display: flex;
      background: var(--spectrum-gray-100);
      border-radius: var(--spectrum-corner-radius-200);
      justify-content: center;

      padding: var(--spectrum-global-dimension-size-100);
      margin: 4px;

      filter: drop-shadow(
        var(--spectrum-drop-shadow-color) 0px var(--spectrum-drop-shadow-y)
          var(--spectrum-drop-shadow-blur)
      );
    }
  `;
__decorate([
    (0, context_1.consume)({ context: context_2.appStateContext, subscribe: true })
], Taskbar.prototype, "appState", void 0);
__decorate([
    (0, context_1.consume)({ context: context_2.apiContext, subscribe: true })
], Taskbar.prototype, "api", void 0);
exports.Taskbar = Taskbar = __decorate([
    (0, decorators_js_1.customElement)('ic-spectrum-taskbar')
], Taskbar);
//# sourceMappingURL=taskbar.js.map